fLoadTexture proto hBmp:dword,Wrap:dword

.code

fEnableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER 
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGL endp

fEnableOpenGLBitmap proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_SUPPORT_OPENGL or PFD_SUPPORT_GDI or PFD_DRAW_TO_BITMAP
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGLBitmap endp

fDisableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	
	invoke wglMakeCurrent,0,0
	mov edx,lpwRC
	invoke wglDeleteContext,[edx]
	ret
fDisableOpenGL endp



fDrawTri proc uses esi edi lpfTri:dword,nFlag:dword
	LOCAL nIndex:dword
	LOCAL texture:dword
	
	mov esi,lpfTri
	
	
	
	invoke glEnable,GL_TEXTURE_2D
	invoke glBindTexture,GL_TEXTURE_2D,[esi].fTri.TexID
	
	;jmp @f
	xor ecx,ecx
	loop_each_vertex:
	pushad
		inc ecx
		mov nIndex,ecx
		invoke glBegin,nFlag
			invoke fTriGetVertexData,lpfTri,nIndex
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
			mov ecx,nIndex
			add ecx,1
			invoke fTriGetVertexData,lpfTri,ecx
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
			mov ecx,nIndex
			add ecx,2
			invoke fTriGetVertexData,lpfTri,ecx
			push eax
			invoke glNormal3f,[eax].fTriData.NormalX,[eax].fTriData.NormalY,[eax].fTriData.NormalZ
			pop eax
			push eax
			invoke glTexCoord2f,[eax].fTriData.U,[eax].fTriData.V
			pop eax
			push eax
			invoke glVertex3f,[eax].fTriData.PositionX,[eax].fTriData.PositionY,[eax].fTriData.PositionZ
			pop eax
			
		invoke glEnd
	popad
	add ecx,3
	cmp ecx,[esi].fTri.nVertex
	jl loop_each_vertex
	@@:
	
;	invoke glBegin,GL_QUADS
;		invoke glTexCoord2f,CFLT(0.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(0.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(-1.0)
;		invoke glTexCoord2f,CFLT(1.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(1.0),CFLT(1.0)
;		invoke glTexCoord2f,CFLT(0.0),CFLT(1.0)
;		invoke glVertex2f,CFLT(-1.0),CFLT(1.0)
;	invoke glEnd
	
	invoke glBindTexture,GL_TEXTURE_2D,0
	
	ret
fDrawTri endp